﻿namespace LINQ
{
    /// <summary>
    /// LINQ - Letecke katastrofy
    /// 
    /// Vasim ukolem bude psat serie dotazu
    /// nad kolekcemi nasledujicich 3 trid:
    /// 
    /// I.   AirCrash - predstavuje leteckou
    ///      nehodu, pro podrobnejsi info se
    ///      podivejte do slozky Model v 
    ///      projektu DataLoader, nebo pres
    ///      IntelliSense
    /// II.  Aircraft - predstavuje letadlo
    /// III. Carrier - predstavuje dopravce
    /// 
    /// zminene kolekce jsou jednoduse 
    /// pristupne skrze statickou tridu 
    /// DataContext. 
    /// Zadani dotazu naleznete ve tride 
    /// Tasks, svou implementaci si 
    /// muzete vyzkouset odkomentovanim 
    /// vypisu pod danym dotazem.
    /// 
    /// Tip: pri implementaci dotazu by 
    /// se mohl hodit LINQ cheatsheet:
    /// http://nickberardi.com/content/images/2008/02/linq-standard-query-operators.pdf
    /// </summary>
    class Program
    {       
        static void Main(string[] args)
        {   
            Tasks.Task01();
            Tasks.Task02();
            Tasks.Task03();
            Tasks.Task04();
            Tasks.Task05();
            Tasks.Task06();
        }

    }
}
